float2 Mult(float2 z1,float2 z2)
{
	return (float2)(z1.x*z2.x-z1.y*z2.y, z1.y*z2.x+z1.x*z2.y);
}

float2 DoIter(float2 z,float2 c)
{
	return Mult(Mult(Mult(Mult(z,z),z),z),z)+c;
}

__kernel void CalcMandel(float Border,float Threshold,uint NumOfIter,uint Size,__global uchar *Data/*,__global uint *NumOfPoints*/)
{
	size_t _X=get_global_id(0);
	size_t _Y=get_global_id(1);
	if((_X<Size) && (_Y<Size))
	{
		float2 c=(float2)(Border*2.0f*((float)_X/(float)(Size-1)-0.5f),Border*2.0f*((float)(Size-_Y-1)/(float)(Size-1)-0.5f));
		float2 z=(float2)(0,0);
		for(uint i=0;(i<NumOfIter) && (length(z)<Threshold);i++)
		{
			z=DoIter(z,c);
		}
		uchar Val;
		if(length(z)<Threshold)
		{
			Val=1;
		}
		else
		{
			Val=0;
		}
		Data[_X+Size*_Y]=Val;
		barrier(CLK_GLOBAL_MEM_FENCE);
		if(Val==1)
		{
			if((Data[_X+Size*_Y-1]==1) && (Data[_X+Size*_Y+1]==1))
			{
				if((Data[_X+Size*(_Y-1)-1]==1) && (Data[_X+Size*(_Y-1)]==1) && (Data[_X+Size*(_Y-1)+1]==1))
				{
					if((Data[_X+Size*(_Y+1)-1]==1) && (Data[_X+Size*(_Y+1)]==1) && (Data[_X+Size*(_Y+1)+1]==1))
					{
						Val=0;
					}
				}
			}
		}
		barrier(CLK_GLOBAL_MEM_FENCE);
		Data[_X+Size*_Y]=Val;
	}
	else
	{
		barrier(CLK_GLOBAL_MEM_FENCE);
		barrier(CLK_GLOBAL_MEM_FENCE);
	}
}